program faitcarte;

{$N+,E-,I-}

const
  degre = 3.14159265358979323846264338327950288419716939937510/180;
  marge = 14.17322835;
  taillex = 595.2755906;
  tailley = 841.8897638;
  cenx = taillex/2;
  ceny = tailley/2;
  cartouchex = 170.0787402;
  cartouchey = 45.35433071;
  eps = 0.02;
  rayequ = 3437.746251; { En milles }
  raypol = 3426.219974;

const
  chiffres : array[0..9] of char = '0123456789';

type
  cartetype = (orthographique,gnomonique,stereographique,polaire,
    mercator,mollweide,sinusoidale,
    lambertazimuthale,albersmodifiee,lambertcylindrique,
    equirectangulaire,equirectangulairecentre);

var
  inf,ps : text;
  carte : cartetype;
  titre,sstitre,projecnom : string;
  tournee : boolean;
  lat0,lon0,taille,rayon : extended;
  precis : word;
  ux,uy,uz,vx,vy,vz,wx,wy,wz : extended;
  px,py,pz,pu,pv,pw : extended;
  prx,pry : extended;
  latb0,latb1,latb2,latb3,lonb0,lonb1,lonb2,lonb3 : extended;
  plt,ult,ust,ufl : boolean;
  t,t1,t2,t3,t4,t5,t6,lt,lt1,lt2,lt3 : extended;
  ct,ct1,ct2 : extended;
  s,s1,s2,s3,s4 : string;
  i,j,k,l,li,lj,lk,ll : longint;
  index,index2 : byte;
  code : integer;
  io : word;

const
  maxpoints = 1000;

var
  nbpoints : word;
  points : array[0..maxpoints-1] of record
    lat,lon : double;
  end;
  otyp : shortint;
  onom : string;
  torient,ttaille,tofsx,tofsy : extended;
  tpolice : byte;

function trueint(t : extended) : extended;
begin
  if t>=0 then trueint := trunc(t)
    else trueint := trunc(t)-1;
end;

function arccos(t : extended) : extended;
begin
  if t>1 then t := 1;
  if t<-1 then t := -1;
  if t>=0 then arccos := arctan(sqrt(1/(t*t)-1))
    else arccos := pi-arctan(sqrt(1/(t*t)-1));
end;

procedure erreur(s : string);
begin
  writeln(s);
  halt(1);
end;

procedure premier(s : string;var s1 : string;var ind : byte);
begin
  s1 := '';
  ind := 1;
  while (ind<=length(s)) and (s[ind]=' ') do inc(ind);
  while (ind<=length(s)) and (s[ind]<>' ') do
    begin s1 := s1+s[ind]; inc(ind); end;
  while (ind<=length(s)) and (s[ind]=' ') do inc(ind);
end;

function convert(s : string) : string;
const
  cnvrt : array[char] of char
    = (#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$A4,
       #$00,#$00,#$00,#$00,#$B6,#$A7,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,
       #$20,#$21,#$22,#$23,#$24,#$25,#$26,#$27,#$28,#$29,#$2A,#$2B,#$2C,#$2D,#$2E,#$2F,
       #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$3A,#$3B,#$3C,#$3D,#$3E,#$3F,
       #$40,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,
       #$50,#$51,#$52,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$5B,#$5C,#$5D,#$5E,#$5F,
       #$60,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,
       #$70,#$71,#$72,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$7B,#$7C,#$7D,#$7E,#$00,
       #$C7,#$FC,#$E9,#$E2,#$E4,#$E0,#$E5,#$E7,#$EA,#$EB,#$E8,#$EF,#$EE,#$EC,#$C4,#$C5,
       #$C9,#$E6,#$C6,#$F4,#$F6,#$F2,#$FB,#$F9,#$FF,#$D6,#$DC,#$A2,#$A3,#$A5,#$A4,#$A4,
       #$E1,#$ED,#$F3,#$FA,#$F1,#$D1,#$AA,#$BA,#$BF,#$00,#$AC,#$BD,#$BC,#$A1,#$AB,#$BB,
       #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,
       #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,
       #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,
       #$00,#$DF,#$00,#$00,#$00,#$00,#$B5,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,
       #$00,#$00,#$00,#$00,#$00,#$00,#$F7,#$00,#$BA,#$00,#$B7,#$00,#$00,#$B2,#$00,#$00);
var
  li : byte;
  chn : char;
  sn : string;
begin
  sn := '(';
  for li := 1 to length(s) do begin
    chn := cnvrt[s[li]];
    if chn='(' then sn := sn+'\('
    else if chn=')' then sn := sn+'\)'
    else if chn='\' then sn := sn+'\\'
    else if (chn>=#32) and (chn<=#126) then sn := sn+chn
    else begin
      sn := sn+'\'+char(byte(chn) div 64+48)+char((byte(chn) div 8) mod 8+48)
        +char(byte(chn) mod 8+48);
    end;
  end;
  sn := sn+')';
  convert := sn;
end;

function latdesc(lat : extended) : string;
var
  t : extended;
  i : longint;
  s : string;
begin
  if lat<0 then begin t := -lat; s := 'S'; end else begin t := lat; s := 'N'; end;
  i := trunc(t*60+1E-9);
  s := ' '+chiffres[i div 600]+chiffres[i div 60 mod 10]+''
    +chiffres[i div 10 mod 6]+chiffres[i mod 10]+''''+s;
  latdesc := s;
end;

function londesc(lon : extended) : string;
var
  t : extended;
  i : longint;
  s : string;
begin
  if lon<0 then begin t := -lon; s := 'W'; end else begin t := lon; s := 'E'; end;
  i := trunc(t*60+1E-9);
  s := chiffres[i div 6000]+chiffres[i div 600 mod 10]+chiffres[i div 60 mod 10]+''
    +chiffres[i div 10 mod 6]+chiffres[i mod 10]+''''+s;
  londesc := s;
end;

procedure bezier(x_1,x0,x1,x2 : extended;var b0,b1,b2,b3 : extended);
var
  u0,u1 : extended;
begin
  while x1-x0>180 do x1 := x1-360;
  while x1-x0<-180 do x1 := x1+360;
  while x2-x0>180 do x2 := x2-360;
  while x2-x0<-180 do x2 := x2+360;
  while x_1-x0>180 do x_1 := x_1-360;
  while x_1-x0<-180 do x_1 := x_1+360;
  u0 := (x1-x_1)/2;
  u1 := (x2-x0)/2;
  b0 := x0;
  b1 := u0;
  b2 := 3*(x1-x0)-2*u0-u1;
  b3 := (u0+u1)-2*(x1-x0);
end;

procedure preparecarte;
begin
  tournee := false;
  if (carte=orthographique) or (carte=gnomonique)
    or (carte=stereographique) or (carte=polaire)
    or (carte=albersmodifiee) then begin
    ux := cos(lat0*degre)*cos(lon0*degre);
    uy := cos(lat0*degre)*sin(lon0*degre);
    uz := sin(lat0*degre);
    vx := sin(lat0*degre)*cos(lon0*degre);
    vy := sin(lat0*degre)*sin(lon0*degre);
    vz := -cos(lat0*degre);
    wx := -sin(lon0*degre);
    wy := cos(lon0*degre);
    wz := 0;
  end;
  if (carte=equirectangulaire) or (carte=equirectangulairecentre)
    then ct := cos(lat0*degre);
  case carte of
    orthographique : begin
      writeln(ps,'newpath');
      writeln(ps,'1.0 setlinewidth');
      writeln(ps,cenx:1:3,' ',ceny:1:3,' ',taille:1:3,' 0 360 arc');
      writeln(ps,'gsave stroke grestore clip');
    end;
    mercator,mollweide,sinusoidale,
      lambertcylindrique,equirectangulaire : begin
      tournee := true;
      writeln(ps,'90 rotate');
    end;
  end;
  case carte of
    orthographique : projecnom := 'Projection orthographique';
    gnomonique : projecnom := 'Projection gnomonique';
    stereographique : projecnom := 'Projection strographique conforme';
    polaire : projecnom := 'Projection polaire';
    mercator : projecnom := 'Projection conforme de Mercator';
    mollweide : projecnom := 'Planisphre quivalent de Mollweide';
    sinusoidale : projecnom := 'Projection sinusodale quivalente';
    lambertazimuthale : projecnom := 'Projection azimuthale quivalente de Lambert';
    albersmodifiee : projecnom :=    'Projection quivalente d''Albers';
    lambertcylindrique : projecnom := 'Projection cylindrique quivalente de Lambert';
    equirectangulaire,equirectangulairecentre : projecnom := 'Projection quirectangulaire';
    else projecnom := '';
  end;
end;

function calcule(lat,lon : extended) : boolean;
begin
  lon := lon-360*trueint((lon+180)/360);
  if (carte=orthographique) or (carte=gnomonique)
    or (carte=stereographique) or (carte=polaire)
    or (carte=albersmodifiee) then begin
    px := cos(lat*degre)*cos(lon*degre);
    py := cos(lat*degre)*sin(lon*degre);
    pz := sin(lat*degre);
    pu := px*ux+py*uy+pz*uz;
    pv := px*vx+py*vy+pz*vz;
    pw := px*wx+py*wy+pz*wz;
  end;
  case carte of
    orthographique : begin
      if (pu<-0.5) then begin
        calcule := false;
        exit;
      end else if (pu<0) then begin
        lt := sqrt(pv*pv+pw*pw);
        pv := pv/lt;
        pw := pw/lt;
      end;
      calcule := true;
      prx := pw*taille+cenx;
      pry := -pv*taille+ceny;
    end;
    gnomonique : begin
      if (pu<=0.1) then begin
        calcule := false;
        exit;
      end;
      calcule := true;
      prx := pw*taille/pu+cenx;
      pry := -pv*taille/pu+ceny;
    end;
    stereographique : begin
      if (pu<=-0.9) then begin
        calcule := false;
        exit;
      end;
      calcule := true;
      prx := 2*pw*taille/(pu+1)+cenx;
      pry := -2*pv*taille/(pu+1)+ceny;
    end;
    polaire : begin
      if (pu<=-0.995) then begin
        calcule := false;
        exit;
      end;
      calcule := true;
      lt := arccos(pu);
      lt2 := sqrt(sqr(pv)+sqr(pw));
      prx := pw*lt/lt2*taille+cenx;
      pry := -pv*lt/lt2*taille+ceny;
    end;
    mercator : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-178) or (lt>=178) then begin
        calcule := false;
        exit;
      end;
      prx := lt*taille*degre+ceny;
      if (lat<-85) or (lat>85) then begin
        calcule := false;
        exit;
      end;
      lt1 := (lat/2)*degre+pi/4;
      pry := taille*ln(sin(lt1)/cos(lt1))-cenx;
    end;
    mollweide : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-178) or (lt>=178) then begin
        calcule := false;
        exit;
      end;
      lt2 := 0;
      for li := 1 to 8 do begin
        lt2 := lt2-(2*lt2+sin(2*lt2)-pi*sin(lat*degre))/(2+2*cos(2*lt2));
      end;
      prx := sqrt(8)/180*cos(lt2)*lon*taille+ceny;
      pry := sqrt(2)*sin(lt2)*taille-cenx;
    end;
    sinusoidale : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-178) or (lt>=178) then begin
        calcule := false;
        exit;
      end;
      prx := lt*cos(lat*degre)*taille*degre+ceny;
      pry := lat*taille*degre-cenx;
    end;
    lambertazimuthale : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if ((lt<=-178) or (lt>=178)) and (abs(lat)<45) then begin
        calcule := false;
        exit;
      end;
      lt2 := sqrt(2/(1+cos(lat*degre)*cos(lon*degre)));
      prx := lt2*cos(lat*degre)*sin(lon*degre)*taille+cenx;
      pry := lt2*sin(lat*degre)*taille+ceny;
    end;
    albersmodifiee : begin
      if pu<=-0.9 then begin
        calcule := false;
        exit;
      end;
      if pu>=1 then begin
        lt := 0;
        lt2 := 1;
      end else begin
        lt := sqrt(2-2*pu);
        lt2 := sqrt(1-pu*pu);
      end;
      prx := lt*pw/lt2*taille+cenx;
      pry := -lt*pv/lt2*taille+ceny;
    end;
    lambertcylindrique : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-178) or (lt>=178) then begin
        calcule := false;
        exit;
      end;
      prx := lt*taille*degre+ceny;
      pry := taille*sin(lat*degre)-cenx;
    end;
    equirectangulaire : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-178) or (lt>=178) then begin
        calcule := false;
        exit;
      end;
      prx := lt*ct*taille*degre+ceny;
      pry := taille*lat*degre-cenx;
    end;
    equirectangulairecentre : begin
      lt := lon-lon0;
      lt := lt-360*trueint((lt+180)/360);
      if (lt<=-45) or (lt>=25) or (lat>=70) or (lat<=-10) then begin
        calcule := false;
        exit;
      end;
      prx := lt*ct*taille*degre+436.500;
      pry := taille*(lat-lat0)*degre+371.300;
    end;
  end;
  if tournee then begin
    if sqrt(sqr(prx-ceny)+sqr(pry+cenx))>rayon then begin
      calcule := false;
      exit;
    end;
  end else begin
    if sqrt(sqr(prx-cenx)+sqr(pry-ceny))>rayon then begin
      calcule := false;
      exit;
    end;
  end;
end;

function creelocal(lat,lon,rot : extended) : boolean;
var
  cx,cy,dx,dy,ex,ey : extended;
begin
  if not calcule(lat,lon) then begin
    creelocal := false;
    exit;
  end;
  cx := prx; cy := pry;
  if not calcule(lat+sin(rot*degre)*eps,
    lon+cos(rot*degre)*eps/cos(lat*degre)) then begin
    creelocal := false;
    exit;
  end;
  dx := (prx-cx)/eps; dy := (pry-cy)/eps;
  if not calcule(lat+cos(rot*degre)*eps,
    lon-sin(rot*degre)*eps/cos(lat*degre)) then begin
    creelocal := false;
    exit;
  end;
  ex := (prx-cx)/eps; ey := (pry-cy)/eps;
  writeln(ps,'gsave');
  writeln(ps,'[ ',dx:1:5,' ',dy:1:5,' ',ex:1:5,' ',ey:1:5,' ',
    cx:1:5,' ',cy:1:5,' ] concat');
end;

function policenom(pol : byte) : string;
begin
  case pol of
    0 : policenom := '/NewCenturySchlbk-Roman`ISOLatin1';
    1 : policenom := '/NewCenturySchlbk-Italic`ISOLatin1';
    2 : policenom := '/NewCenturySchlbk-Bold`ISOLatin1';
    3 : policenom := '/NewCenturySchlbk-BoldItalic`ISOLatin1';
  end;
end;

procedure entete;
begin
  writeln(ps,'statusdict /jobname (Carte) put');
  writeln(ps,'errordict begin');
  writeln(ps,'/errhelpdict 12 dict def');
  writeln(ps,'errhelpdict begin');
  writeln(ps,'/stackunderflow (operand stack underflow) def');
  writeln(ps,'/undefined (undefined object) def');
  writeln(ps,'/typecheck (wrong argument type) def');
  writeln(ps,'/nocurrentpoint (no current point) def');
  writeln(ps,'/dictstackunderflow (extra end encountered) def');
  writeln(ps,'end');
  writeln(ps,'/handleerror {');
  writeln(ps,'$error begin');
  writeln(ps,'newerror {');
  writeln(ps,'/newerror false def');
  writeln(ps,'showpage');
  writeln(ps,'/x 18 def /y 691.2 def');
  writeln(ps,'/Helvetica 14.4 selectfont');
  writeln(ps,'x y moveto');
  writeln(ps,'(Offending command = ) show');
  writeln(ps,'/command load');
  writeln(ps,'{');
  writeln(ps,'dup type');
  writeln(ps,'/stringtype ne {');
  writeln(ps,'(Max error string) cvs');
  writeln(ps,'} if');
  writeln(ps,'show');
  writeln(ps,'} exec');
  writeln(ps,'/y y 14.4 sub def');
  writeln(ps,'x y moveto');
  writeln(ps,'(Error = ) show');
  writeln(ps,'errorname');
  writeln(ps,'{');
  writeln(ps,'dup type dup');
  writeln(ps,'(Max error string) cvs');
  writeln(ps,'show');
  writeln(ps,'( : ) show');
  writeln(ps,'/stringtype ne {');
  writeln(ps,'(Max error string) cvs');
  writeln(ps,'} if');
  writeln(ps,'show');
  writeln(ps,'} exec');
  writeln(ps,'errordict begin');
  writeln(ps,'errhelpdict errorname known {');
  writeln(ps,'x 72 add y 14.4 sub moveto');
  writeln(ps,'errhelpdict errorname get');
  writeln(ps,'show');
  writeln(ps,'} if');
  writeln(ps,'end');
  writeln(ps,'/y y 28.8 sub def');
  writeln(ps,'x y moveto');
  writeln(ps,'(Stack =) show');
  writeln(ps,'ostack {');
  writeln(ps,'/y y 14.4 sub def');
  writeln(ps,'x 72 add y moveto');
  writeln(ps,'dup type');
  writeln(ps,'/stringtype ne {');
  writeln(ps,'(Max error string) cvs');
  writeln(ps,'} if');
  writeln(ps,'show');
  writeln(ps,'} forall');
  writeln(ps,'showpage');
  writeln(ps,'} if');
  writeln(ps,'end');
  writeln(ps,'} def');
  writeln(ps,'end');
  writeln(ps,'/fntreencode {');
  writeln(ps,'/fntnewname exch def /fntoldname exch def');
  writeln(ps,'/fntolddict fntoldname findfont def');
  writeln(ps,'/fntnewdict fntolddict maxlength dict def');
  writeln(ps,'fntolddict {');
  writeln(ps,'exch dup /FID ne {');
  writeln(ps,'dup /Encoding ne {');
  writeln(ps,'exch fntnewdict 3 1 roll put');
  writeln(ps,'} {');
  writeln(ps,'exch pop ISOLatin1Encoding fntnewdict 3 1 roll put');
  writeln(ps,'} ifelse');
  writeln(ps,'} { pop pop } ifelse');
  writeln(ps,'} forall');
  writeln(ps,'fntnewdict /FontName fntnewname put');
  writeln(ps,'fntnewname fntnewdict definefont pop');
  writeln(ps,'} bind def');
  writeln(ps,'/NewCenturySchlbk-Roman /NewCenturySchlbk-Roman`ISOLatin1 fntreencode');
  writeln(ps,'/NewCenturySchlbk-Italic /NewCenturySchlbk-Italic`ISOLatin1 fntreencode');
  writeln(ps,'/NewCenturySchlbk-Bold /NewCenturySchlbk-Bold`ISOLatin1 fntreencode');
  writeln(ps,'/NewCenturySchlbk-BoldItalic /NewCenturySchlbk-BoldItalic`ISOLatin1 fntreencode');
  writeln(ps,'/fnt {');
  writeln(ps,'/hgt exch def hgt selectfont');
(*  writeln(ps,'/wdt (m) stringwidth pop def'); *)
  writeln(ps,'} bind def');
  writeln(ps,'/boxset {');
  writeln(ps,'exch 1 add 2 div 2 index stringwidth pop mul neg');
  writeln(ps,'exch 1 add 2 div hgt mul neg rmoveto');
  writeln(ps,'show');
  writeln(ps,'} bind def');
  writeln(ps,'/ville {');
  writeln(ps,'0 setgray');
  writeln(ps,'0 setlinewidth');
  writeln(ps,'0 0 moveto');
  writeln(ps,'-0.2 -0.2 rmoveto');
  writeln(ps,'0.4 0.4 rlineto');
  writeln(ps,'-0.4 0 rmoveto');
  writeln(ps,'0.4 -0.4 rlineto stroke');
  writeln(ps,'0 0 moveto boxset');
  writeln(ps,'} bind def');
  writeln(ps,'initgraphics');
  writeln(ps,'1 setlinecap');
  writeln(ps,'1 setlinejoin');
  writeln(ps,'[] 0 setdash');
  writeln(ps,'0 setgray');
  writeln(ps,'0 setlinewidth');
  writeln(ps,marge:1:3,' ',marge:1:3,' moveto');
  writeln(ps,taillex-marge:1:3,' ',marge:1:3,' lineto');
  writeln(ps,taillex-marge:1:3,' ',tailley-marge:1:3,' lineto');
  writeln(ps,marge:1:3,' ',tailley-marge:1:3,' lineto');
  writeln(ps,'closepath clip');
  writeln(ps,'gsave');
end;

begin
  carte := stereographique;
  titre := 'Centre d''Anecdar';
  sstitre := '(Centr sur Tekir)';
  lat0 := 51+30/60;
  lon0 := -(12+19/60);
  taille := 800;
  rayon := 900;
  precis := 15;
  assign(inf,'ANECDAR.DAT');
  reset(inf);
  assign(ps,'CARTE.PS');
  rewrite(ps);
  writeln(ps,'%Programme gographique d''Anecdar');
  entete;
  preparecarte;
  writeln(ps,'%Dbut');
  while not eof(inf) do begin
    readln(inf,s);
    io := ioresult;
    if io<>0 then erreur('Erreur E/S');
    if s='' then erreur('Erreur: ligne blanche');
    premier(s,s1,index);
    if s1='@GRILLE' then otyp := 0
    else if s1='@VILLE' then otyp := 1
    else if s1='@RIVIERE' then otyp := 2
    else if s1='@COTE' then otyp := 3
    else if s1='@FORET' then otyp := 4
    else if s1='@MONTAGNES' then otyp := 5
    else if s1='@DESERT' then otyp := 6
    else if s1='@TEXTE' then otyp := -1
    else erreur('Instruction inconnue: '+s1);
    if otyp=0 then begin
      writeln(ps,'0 setgray');
      writeln(ps,'0 setlinewidth');
      writeln(ps,'newpath');
      t1 := -80;
      while t1<90 do begin
        writeln('Parallle ',t1:1:0);
        writeln(ps,'%Parallle ',t1:1:0);
        t2 := -180;
        ult := false;
        ust := false;
        ufl := true;
        while t2<=181 do begin
          plt := calcule(t1,t2);
          if plt then begin
            if ult then writeln(ps,prx:1:2,' ',pry:1:2,' lineto')
              else writeln(ps,prx:1:2,' ',pry:1:2,' moveto');
          end;
          ult := plt;
          ust := ust or plt;
          ufl := ufl and plt;
          t2 := t2+5/precis;
        end;
        if ust then writeln(ps,'stroke');
        t1 := t1+10;
      end;
      t2 := 0;
      while t2<360 do begin
        writeln('Mridien ',t2:1:0);
        writeln(ps,'%Mridien ',t2:1:0);
        t1 := -90;
        ult := false;
        ust := false;
        ufl := true;
        while t1<=90 do begin
          plt := calcule(t1,t2);
          if plt then begin
            if ult then writeln(ps,prx:1:2,' ',pry:1:2,' lineto')
              else writeln(ps,prx:1:2,' ',pry:1:2,' moveto');
          end;
          ult := plt;
          ust := ust or plt;
          ufl := ufl and plt;
          t1 := t1+5/precis;
        end;
        if ust then writeln(ps,'stroke');
        t2 := t2+10;
      end;
      writeln(ps,'[ 5.0 3.0 0.5 3.0 ] 0 setdash');
      for i := 1 to 4 do begin
        if i=1 then begin
          t1 := 23+26/60+57/3600;
          writeln('Tropique du Cancer');
          writeln(ps,'%Tropique du Cancer');
        end else if i=2 then begin
          t1 := -23-26/60-57/3600;
          writeln('Tropique du Capricorne');
          writeln(ps,'%Tropique du Capricorne');
        end else if i=3 then begin
          t1 := 90-23-26/60-57/3600;
          writeln('Cercle polaire arctique');
          writeln(ps,'%Cercle polaire arctique');
        end else if i=4 then begin
          t1 := -90+23+26/60+57/3600;
          writeln('Cercle polaire antarctique');
          writeln(ps,'%Cercle polaire antarctique');
        end;
        t2 := -180;
        ult := false;
        ust := false;
        ufl := true;
        while t2<=181 do begin
          plt := calcule(t1,t2);
          if plt then begin
            if ult then writeln(ps,prx:1:2,' ',pry:1:2,' lineto')
              else writeln(ps,prx:1:2,' ',pry:1:2,' moveto');
          end;
          ult := plt;
          ust := ust or plt;
          ufl := ufl and plt;
          t2 := t2+5/precis;
        end;
        if ust then writeln(ps,'stroke');
      end;
      writeln(ps,'[ ] 0 setdash');
    end else begin
      onom := '';
      torient := 0;
      ttaille := 0.7;
      tofsx := 0;
      if otyp=1 then tofsy := -1.6 else tofsy := -1.0;
      if otyp=1 then tpolice := 1 else tpolice := 0;
      nbpoints := 0;
      repeat
        if eof(inf) then erreur('Fin de fichier inattendue');
        readln(inf,s);
        io := ioresult;
        if io<>0 then erreur('Erreur E/S');
        premier(s,s1,index);
        if s1='@NOM' then begin
          s2 := copy(s,index,length(s)-index+1);
          if s2[1]<>'"' then erreur('Erreur dans la chane: '+s2);
          i := 2;
          onom := '';
          while (i<=length(s2)) and (s2[i]<>'"') do begin
            onom := onom+s2[i];
            inc(i);
          end;
          if i>length(s2) then erreur('Erreur dans la chane: '+s2);
          writeln(onom);
          writeln(ps,'%',onom);
        end else if s1='@TAILLE' then begin
          if (otyp<>-1) and (otyp<>1) then erreur('Commande inapplicable');
          s2 := copy(s,index,length(s)-index+1);
          val(s2,ttaille,code);
          if code<>0 then erreur('Erreur de format numrique');
        end else if s1='@ORIENT' then begin
          if (otyp<>-1) and (otyp<>1) then erreur('Commande inapplicable');
          s2 := copy(s,index,length(s)-index+1);
          val(s2,torient,code);
          if code<>0 then erreur('Erreur de format numrique');
        end else if s1='@OFFSET' then begin
          if (otyp<>-1) and (otyp<>1) then erreur('Commande inapplicable');
          s2 := copy(s,index,length(s)-index+1);
          premier(s2,s3,index2);
          s4 := copy(s2,index2,length(s)-index2+1);
          val(s3,tofsx,code);
          if code<>0 then erreur('Erreur de format numrique');
          val(s4,tofsy,code);
          if code<>0 then erreur('Erreur de format numrique');
        end else if s1='@POLICE' then begin
          s2 := copy(s,index,length(s)-index+1);
          if s2='ROMAN' then tpolice := 0
          else if s2='ITALIC' then tpolice := 1
          else if s2='BOLD' then tpolice := 2
          else if s2='BOLDITALIC' then tpolice := 3
          else erreur('Police inconnue');
        end else if s1='@MARQUEUR' then
        else if s1='@COMMENTAIRE' then
        else if s1='' then erreur('Erreur: ligne blanche')
        else if s1='@STOP' then
        else if s1[1]='@' then erreur('Instruction inconnue: '+s1)
        else if s1[1]='[' then begin
          i := 2;
          s2 := '';
          while (i<=length(s1)) and (s1[i]<>';') and (s1[i]<>']') do begin
            s2 := s2+s1[i];
            inc(i);
          end;
          if (i>length(s1)) or (s2[i]=']') then erreur('Erreur de syntaxe');
          inc(i);
          s3 := '';
          while (i<=length(s1)) and (s1[i]<>';') and (s1[i]<>']') do begin
            s3 := s3+s1[i];
            inc(i);
          end;
          if (i>length(s1)) or (s2[i]=';') then erreur('Erreur de syntaxe');
          val(s2,points[nbpoints].lat,code);
          if code<>0 then erreur('Erreur de format numrique');
          val(s3,points[nbpoints].lon,code);
          if code<>0 then erreur('Erreur de format numrique');
          inc(nbpoints);
          if nbpoints>=maxpoints then erreur('Trop de points dans l''objet');
        end else erreur('Erreur de syntaxe');
        if ((otyp=1) or (otyp=-1)) and (nbpoints>1)
          then erreur('@STOP attendu');
      until s1='@STOP';
      writeln(ps,'newpath');
      if otyp=1 then begin
        if creelocal(points[0].lat,points[0].lon,torient) then begin
          writeln(ps,policenom(tpolice),' ',ttaille:1:4,
            ' fnt');
          writeln(ps,convert(onom),' ',tofsx:1:2,' ',tofsy:1:2,' ville');
          writeln(ps,'grestore');
        end;
      end else if otyp=-1 then begin
        if creelocal(points[0].lat,points[0].lon,torient) then begin
          writeln(ps,policenom(tpolice),' ',ttaille:1:4,
            ' fnt');
          writeln(ps,'0 0 moveto');
          writeln(ps,convert(onom),' ',tofsx:1:2,' ',tofsy:1:2,' boxset');
          writeln(ps,'grestore');
        end;
      end else begin
        ult := false;
        ust := false;
        ufl := true;
        for i := 0 to nbpoints-1 do begin
          if precis=1 then begin
            plt := calcule(points[i].lat,points[i].lon);
            if plt then begin
              if ult then writeln(ps,prx:1:2,' ',pry:1:2,' lineto')
                else writeln(ps,prx:1:2,' ',pry:1:2,' moveto');
            end;
            ult := plt;
            ust := ust or plt;
            ufl := ufl and plt;
          end else begin
            if (otyp=2) and (i=0) then begin
              bezier(points[0].lat,points[0].lat,points[1].lat,points[2].lat,
                latb0,latb1,latb2,latb3);
              bezier(points[0].lon,points[0].lon,points[1].lon,points[2].lon,
                lonb0,lonb1,lonb2,lonb3);
            end else if (otyp=2) and (i=nbpoints-2) then begin
              bezier(points[i-1].lat,points[i].lat,points[i+1].lat,points[i+1].lat,
                latb0,latb1,latb2,latb3);
              bezier(points[i-1].lon,points[i].lon,points[i+1].lon,points[i+1].lon,
                lonb0,lonb1,lonb2,lonb3);
            end else if (otyp=2) and (i=nbpoints-1) then begin
              bezier(points[i].lat,points[i].lat,points[i].lat,points[i].lat,
                latb0,latb1,latb2,latb3);
              bezier(points[i].lon,points[i].lon,points[i].lon,points[i].lon,
                lonb0,lonb1,lonb2,lonb3);
            end else begin
              bezier(points[(i+nbpoints-1) mod nbpoints].lat,
                points[i].lat,
                points[(i+1) mod nbpoints].lat,
                points[(i+2) mod nbpoints].lat,latb0,latb1,latb2,latb3);
              bezier(points[(i+nbpoints-1) mod nbpoints].lon,
                points[i].lon,
                points[(i+1) mod nbpoints].lon,
                points[(i+2) mod nbpoints].lon,lonb0,lonb1,lonb2,lonb3);
            end;
            for j := 0 to precis-1 do begin
              t := j/precis;
              t1 := latb0+latb1*t+latb2*t*t+latb3*t*t*t;
              t2 := lonb0+lonb1*t+lonb2*t*t+lonb3*t*t*t;
              plt := calcule(t1,t2);
              if plt then begin
                if ult then writeln(ps,prx:1:2,' ',pry:1:2,' lineto')
                  else writeln(ps,prx:1:2,' ',pry:1:2,' moveto');
              end;
              ult := plt;
              ust := ust or plt;
              ufl := ufl and plt;
            end;
          end;
        end;
        if ust then begin
          case otyp of
            2 : begin
              writeln(ps,'0 setgray');
              writeln(ps,1.5E-3*taille:1:3,' setlinewidth');
              writeln(ps,'stroke');
            end;
            3 : begin
              writeln(ps,'0 setgray');
              writeln(ps,1.2E-3*taille:1:3,' setlinewidth');
              if ufl then writeln(ps,'closepath');
              writeln(ps,'stroke');
            end;
            4 : begin
              if ufl then begin
                writeln(ps,'closepath');
                writeln(ps,'gsave');
                writeln(ps,'0.2 1 0.4 setrgbcolor');
                writeln(ps,'fill');
                writeln(ps,'grestore');
              end;
              writeln(ps,'0 setgray');
              writeln(ps,7E-4*taille:1:3,' setlinewidth');
              writeln(ps,'stroke');
            end;
            5 : begin
              if ufl then begin
                writeln(ps,'closepath');
                writeln(ps,'gsave');
                writeln(ps,'0.3 setgray');
                writeln(ps,'fill');
                writeln(ps,'grestore');
              end;
              writeln(ps,'0 setgray');
              writeln(ps,'0 setlinewidth');
              writeln(ps,'stroke');
            end;
            6 : begin
              if ufl then begin
                writeln(ps,'closepath');
                writeln(ps,'gsave');
                writeln(ps,'1 1 0.5 setrgbcolor');
                writeln(ps,'fill');
                writeln(ps,'grestore');
              end;
              writeln(ps,'0 setgray');
              writeln(ps,'1.2 setlinewidth');
              writeln(ps,'[ 0.1 4 ] 0 setdash');
              writeln(ps,'stroke');
              writeln(ps,'[ ] 0 setdash');
            end;
          end;
        end;
      end;
    end;
  end;
  writeln(ps,'grestore');
  if tournee then begin
    writeln(ps,'90 rotate');
    writeln(ps,tailley-2*marge-cartouchex:1:3,' ',
      -taillex+2*marge:1:3,' translate');
  end else begin
    writeln(ps,taillex-2*marge-cartouchex:1:3,' ',
      2*marge:1:3,' translate');
  end;
  writeln(ps,'newpath');
  writeln(ps,'1.2 setlinewidth');
  writeln(ps,'0 0 moveto');
  writeln(ps,cartouchex:1:3,' 0 lineto');
  writeln(ps,cartouchex:1:3,' ',cartouchey:1:3,' lineto');
  writeln(ps,'0 ',cartouchey:1:3,' lineto');
  writeln(ps,'closepath gsave 1 setgray fill grestore stroke');
  writeln(ps,'/NewCenturySchlbk-Bold`ISOLatin1 10 fnt');
  writeln(ps,cartouchex/2:1:3,' ',cartouchey-10:1:3,' moveto');
  writeln(ps,convert(titre),' 0.0 -1.0 boxset');
  writeln(ps,'/NewCenturySchlbk-Bold`ISOLatin1 8 fnt');
  writeln(ps,cartouchex/2:1:3,' ',cartouchey-18.5:1:3,' moveto');
  writeln(ps,convert(sstitre),' 0.0 -1.0 boxset');
  writeln(ps,'/NewCenturySchlbk-Italic`ISOLatin1 7 fnt');
  writeln(ps,cartouchex/2:1:3,' ',cartouchey-26:1:3,' moveto');
  writeln(ps,convert(projecnom),' 0.0 -1.0 boxset');
  writeln(ps,'/NewCenturySchlbk-Roman`ISOLatin1 7 fnt');
  writeln(ps,cartouchex/2:1:3,' ',cartouchey-33:1:3,' moveto');
  writeln(ps,convert('Echelle en latitude  '+latdesc(lat0)+' (milles) :'),
    ' 0.0 -1.0 boxset');
  writeln(ps,'/NewCenturySchlbk-Roman`ISOLatin1 4 fnt');
  t3 := arctan((rayequ/raypol)*sin(lat0*degre)/cos(lat0*degre));
  plt := calcule(lat0,lon0);
  t1 := prx;
  t2 := pry;
  plt := calcule(lat0+eps,lon0);
  t := sqrt(sqr(t1-prx)+sqr(t2-pry))/eps/degre/
    sqrt(sqr(rayequ*sin(t3*degre))+sqr(raypol*cos(t3*degre)));
  i := 1;
  j := 0;
  while (t<=20) do begin
    if j mod 3=1 then begin
      i := i*5 div 2;
      t := t*2.5;
    end else begin
      i := i*2;
      t := t*2;
    end;
    inc(j);
  end;
  j := trunc((cartouchex-2*marge)/t);
  writeln(ps,'newpath');
  writeln(ps,'0 setlinewidth');
  writeln(ps,(cartouchex-j*t)/2:1:3,' ',cartouchey-41:1:3,' moveto');
  writeln(ps,(cartouchex+j*t)/2:1:3,' ',cartouchey-41:1:3,' lineto');
  writeln(ps,'stroke');
  for k := 0 to j do begin
    t2 := (cartouchex-j*t)/2+k*t;
    writeln(ps,t2:1:3,' ',cartouchey-40:1:3,' moveto');
    writeln(ps,t2:1:3,' ',cartouchey-42:1:3,' lineto');
    writeln(ps,'stroke');
    writeln(ps,t2:1:3,' ',cartouchey-38:1:3,' moveto');
    writeln(ps,'(',i*k,') 0.0 -1.0 boxset');
  end;
  writeln(ps,'showpage');
  writeln(ps,'quit');
  close(ps);
  close(inf);
end.